#!/usr/bin/env python

class Closure:
    def __init__(self, body, args):
        self.body = body
        self.args = args

def Exec(stmts):
    def evalExp(e,env):
        # TODO: Lookup the value of "name" in "env" in the current and previous frames! Fix me.
        def lookup(name,env):
            return env[name]

        if (e[0] == 'int-lit'):   return e[1]
        if (e[0] == 'var'):       return lookup(e[1],env)
        if (e[0] == '+'):         return evalExp(e[1], env) + evalExp(e[2], env)
        # This only works if functions have no arguments. 
        # It is your job to add argument support to it  
        if (e[0] == 'call'):      return doCall(evalExp(e[1], env), env)
        # This do not handle closure. What else do you need to return?
        if (e[0] == 'lambda'):    return Closure(e[2], e[1])
        if (e[0] == 'ite'):       return [evalExp(e[2],env),evalExp(e[3],env)][not evalExp(e[1],env)]
        raise SyntaxError("Illegal or Unimplemented AST node: " + str(e))
    
    def evalStmt(stmts,env):
        # TODO: Update the environment: variable "name" must be bound to "val"
        def update(name,env,val):
            raise NameError("CS164 TODO: Write me")

        val = None
        for s in stmts:
            if   s[0] == 'exp'  : val = evalExp(s[1],env)
            elif s[0] == 'def'  : val = evalExp(s[2],env); env[s[1]] = val
            elif s[0] == 'print': print(evalExp(s[1],env))
        return val
        
    # TODO: Perform a call. The crucial steps are:
    # 1. Create a new frame
    # 2. Link the new frame and the old one.
    # 3. Add argument bindings to the new frame.
    def doCall(closure, env):
        return evalStmt(closure.body, env)
          
    return evalStmt(stmts, { "__up__": None})
    
def Run(ast):
    #print "The AST is "
    #print ast
    Exec(ast)
