#!/usr/bin/env python
# Interface to our online parser

import json, sys, interpreter
from itertools import chain
from os.path import abspath
from urllib import urlencode
from urllib2 import urlopen

if __name__ == '__main__':
    if len(sys.argv) != 2:
        print "Please give one argument, the input filename."
        sys.exit(1)
        
    server_url = ('http://inst.eecs.berkeley.edu/~cs164/fa10/'
                  'reference-parser/parser.cgi')
    server_grammar = 'cs164a.grm'
    cs164input = open(sys.argv[1]).read()

    # Construct the URL query string.
    query_parameters = [('input', cs164input)]
    if server_grammar is not None:
        query_parameters.append(('server_grammar', server_grammar))
    query = urlencode(query_parameters)

    response = json.load(urlopen(server_url, query))
    
    if 'error' in response:
        print "Server error" + response['error']
        exit(-1)
    else:
        ast = eval(response[response.keys()[0]])
        if ast == None:
            print "Syntax error in input file"
        else:
            interpreter.Run(ast)
